/*
 *	main.c
 *
 *	yZזz񂩂yjz(ڐA)
 *
 *	* Mon Jul 07 19:00:00 JST 2008 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SOUND
const void* sound_table[SOUND_COUNT];
#endif /*USE_SOUND*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/* (yRyA) */
//void draw_primitive_wz(RENDVERTEX vertices[/*n_vertices*/], int n_vertices, DSLPARAM* param, DSLPROC draw_scanline);	/* framdp1.c {{2008/01/13:ǉ}} */ /* {{2008/01/14:폜}} */
void draw_scanline_wz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds11.c */
void draw_scanline_wz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)		{ DIE(); }	/* framds12.c */
void draw_scanline_wz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds13.c */
void draw_scanline_wz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)		{ DIE(); }	/* framds14.c */
void draw_scanline_wz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds15.c */
/* (yRyAȂ) */
//void draw_primitive_woz(RENDVERTEX vertices[/*n_vertices*/], int n_vertices, DSLPARAM* param, DSLPROC draw_scanline);	/* framdp2.c {{2008/01/13:ǉ}} */ /* {{2008/01/14:폜}} */
void draw_scanline_woz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds21.c */
void draw_scanline_woz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds22.c */
void draw_scanline_woz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds23.c */
void draw_scanline_woz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds24.c */
//void draw_scanline_woz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)	{ DIE(); }	/* framds25.c */

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	game_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef REPEAT_PAD
	pad_set_repeat(REPEAT_PAD, REPEAT_DELAY, REPEAT_INTERVAL);
#endif /*REPEAT_PAD*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef RESOURCE_FNAME
	/* pext@CYt\[X擾܂B */
	resource = resource_address(RESOURCE_FNAME);
#endif /*RESOURCE_FNAME*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_DBG
	/* DBGjbgݒ肵܂B */
	dbg_init();
#endif /*USE_DBG*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

#ifdef USE_2BIT_ADPCM
	/* 2-bit ADPCM DecoderN܂B */
	adpcm_init(ADPCM_CHANNELS);
#endif /*USE_2BIT_ADPCM*/

	/* TEh܂B */
#ifdef USE_SOUND
	{
#define SOUND_(name) { extern const unsigned char name[]; sound_table[SND_##name] = name; }
#define SOUND_RESOURCE_(name,fname) { sound_table[SND_##name] = fpk_address(resource, fname, NULL); }
#include "sound.h"
#undef SOUND_
#undef SOUND_RESOURCE_
	}
#endif /*USE_SOUND*/

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#define TEXTURE_RESOURCE_(name,fname) const void* const name = fpk_address(resource, fname, NULL);
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#define TEXTURE_RESOURCE_(name,fname) name,
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

#ifdef USE_VIDREC
	/* ʏo͂܂B */
	yield(); /* runŎsꍇ̎smFɉ邽߁AUSB@\̐؂ւ͂ɒx点 */
#ifdef LDIRECT_INTERVAL
	cdcacm_start(0, sizeof vbuff / 2, NULL, NULL);
#else /*LDIRECT_INTERVAL*/
	cdcacm_start(0, sizeof vbuff / 4, NULL, NULL);
#endif /*LDIRECT_INTERVAL*/
#endif /*USE_VIDREC*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	pcePadSetTrigMode(PP_MODE_SINGLE);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
/*{{AvP[VL̃N[Abv*/
	/** no job **/
/*}}AvP[VL̃N[Abv*/

#ifdef USE_VIDREC
	/* ʏo͂I܂B */
	cdcacm_stop();
#endif /*USE_VIDREC*/

#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_DBG
	/* DBGjbg̐ݒ܂B */
	dbg_free();
#endif /*USE_DBG*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Mar 10 13:29:56 JST 2008 Naoyuki Sawa
 * - update()AʍXV𕪗A܂B
 */
#ifdef V_SCREEN
/* vbuff(c)_def_vbuff()ϊ */
//static void rotate_screen() {
//	unsigned char *src = &vbuff[88 - 1];	/* ]̉ʂ͍ォ瑖Jn܂ */
//	unsigned char *dst = &_def_vbuff[0];	/* ]̏cʂ͉Eォ瑖Jn܂ */
//	int x = 88;
//	do {
//		int y = 128;
//		do {
//			*dst++ = *src;		/* ʂEɑ܂ */
//			src += 88;		/* cʂɑ܂ */
//		} while(--y);
//						/* ʂ͊Ɏ̍sֈړĂ܂ */
//		src -= 88 * 128 + 1;		/* cʂ̗̈ԏֈړ܂ */
//	} while(--x);
//}
// (C = 9.2ms/1call  ASM = 3.2ms/1call)
/*static*/ void rotate_screen();
asm("
	.code
	.align	1
rotate_screen:
	xld.w	%r12, 0x0e00			; %r12 := FRAM4_START
	xld.w	%r13, rotate_screen_DOX		; %r13 := DOY
	xld.w	%r14, rotate_screen_END		; %r14 := END
	xcall.d	memcpy				; %r10 := FRAM4_START = memcpy(FRAM4_START, DOX, END - DOX)
	sub	%r14, %r13			; %r14 := END - DOY			*delay*
	xld.w	%r4, vbuff+87			; %r4  := src = &vbuff[88 - 1]
	xld.w	%r5, _def_vbuff			; %r5  := dst = &_def_vbuff[0]
	xld.w	%r6, 88				; %r6  := 88
	xld.w	%r7, 128			; %r7  := 128
	xld.w	%r11, 11265			; %r11 := 88 * 128 + 1
	ld.w	%r12, %r6			; %r12 := x = 88
	jp	%r10				; goto FRAM4_START			(jp.d͕s!!)
;//{{FRAM4̈֓]
rotate_screen_DOX:				; do {
	ld.w	%r13, %r7			;   %r13 := y = 128
rotate_screen_DOY:				;   do {
	ld.ub	%r9, [%r4]			;     %r9  := c = *src
	sub	%r13, 1				;     %r13 := --y			*anti-interlock*
	ld.b	[%r5]+, %r9			;     %r5  := *dst++ = c
	jrne.d	rotate_screen_DOY		;   } while(--y)
	add	%r4, %r6			;     %r4  := src += 88			*delay*
	sub	%r12, 1				;   %r12 := --x
	jrne.d	rotate_screen_DOX		; } while(--x)
	sub	%r4, %r11			;   %r4  := src -= 88 * 128 + 1		*delay*
	ret
rotate_screen_END:
;//}}܂FRAM4̈֓]
");
#endif /*V_SCREEN*/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 */
void
update()
{
#ifdef V_SCREEN
	rotate_screen();
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();
}

/****************************************************************************
 *	vidrec
 ****************************************************************************/

#ifdef USE_VIDREC
static void
vidrec()
{
#ifdef LDIRECT_INTERVAL
	static const unsigned char hdr[4] = { DISP_X,DISP_Y,4/*[bpp]*/,FPS };
#else /*LDIRECT_INTERVAL*/
	static const unsigned char hdr[4] = { DISP_X,DISP_Y,2/*[bpp]*/,FPS };
#endif /*LDIRECT_INTERVAL*/
	static int active;
	//
	unsigned char buf[128/**/]; /* (sizeof vbuff)/ÑTCYƂ邱 */
	const unsigned char* src;
	unsigned char* dst;

	if(cdcacm_recv(buf, 1) > 0) {
		switch(buf[0]) {
		case 0:
			active = 0; /* ʏo͒~ */
			break;
		case 1:
			active = 1; /* ʏo͊Jn */
			src = hdr;
			do {
				if(pcePadGetDirect() & PAD_SELECT) {
					exit(0); /* M҂Ɋ荞ŋI */
				}
				src += cdcacm_send(src, &hdr[sizeof hdr] - src);
			} while(src < &hdr[sizeof hdr]);
			break;
		}
	}
	if(active) {
		src = vbuff;
		do {
			dst = buf;
			do {
#ifdef LDIRECT_INTERVAL
				*dst++ = src[0]|(src[1]<<4); 
				src += 2;
#else /*LDIRECT_INTERVAL*/
				*dst++ = src[0]|(src[1]<<2)|(src[2]<<4)|(src[3]<<6);
				src += 4;
#endif /*LDIRECT_INTERVAL*/
			} while(dst < &buf[sizeof buf]);
			dst = buf;
			do {
				if(pcePadGetDirect() & PAD_SELECT) {
					exit(0); /* M҂Ɋ荞ŋI */
				}
				dst += cdcacm_send(dst, &buf[sizeof buf] - dst);
			} while(dst < &buf[sizeof buf]);
		} while(src < &vbuff[sizeof vbuff]);
	}
}
#endif /*USE_VIDREC*/

/****************************************************************************
 *	schedule
 ****************************************************************************/

/* * Fri Dec 15 00:49:15 JST 2006 Naoyuki Sawa
 * - schedule()֐ɁATEh|[YΉR[hǉ܂B
 *   ł͏肭삵Ă悤łAX[v̕Aɖ肪NȂmFłB
 * - A|[YԂ̂܂܁AȂ킿ATEh|[YԂ̂܂܂ŃAvP[VIĂ܂ꍇɂA
 *   CLiPCupceAppExit()pceWaveStop(1)ĂяoĂATEhԂZbĝŁAvłB
 */

void
schedule()
{
#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		/*{{2006/12/15:TEh|[YΉ*/
		int sound_pause = 0/*x}*/;
		/*}}2006/12/15:TEh|[YΉ*/
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/
			/* ʍXVB */
			update();
#ifdef USE_VIDREC
			/* ʏóB */
			vidrec();
#endif /*USE_VIDREC*/
			/* VXeB */
			yield();
			/* pbhԍXVB */
			joy = pad_get();
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					sound_pause = fINT_EDMA.EHDM1;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 0;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 1;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE*/

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

#define BLOCK_MAX			100
#define BLOCK_TYPE_MAX			4

//#define BLOCK_DENSITY_THREATHOLD	4.5f
//P/ECE̓ubN̎ނÂ炭ē̂ŁAՂēՓxB
#define BLOCK_DENSITY_THREATHOLD	4.0f
#define BLOCK_VANISH_DELAY		80
#define BLOCK_INGNITED_EFFECT		7.0f		/* Ύ̎͂ւ̉e{ */

//#define BLOCK_SIZE			32.0f		/* ubN̑傫 */
//P/ECEł͉摜k̉ełubN傫߂łB
#define BLOCK_SIZE			42.0f		/* ubN̑傫 */
#define FIELD_WIDTH			640.0f		/* tB[h */
#define FIELD_HEIGHT			480.0f		/* tB[hc */

#define DRAG_MAX			64.0f

#define BLOCK_REFLECT			0.2f		/* ubNm̔˗ */
#define FIELD_REFLECT			0.8f		/* tB[hƂ̔˗ */

/*--------------------------------------------------------------------------*/

typedef struct _BLOCK {
	int type;			/* ubN̎ */
	float x;			/* xW */
	float y;			/* yW */
	float sx;			/* xy */
	float sy;			/* xy */
	int ignited;			/* Βx^C}[ */
} BLOCK;
BLOCK block_array[BLOCK_MAX];
int block_v_count[BLOCK_TYPE_MAX];	/* ubN */

int play_timer;
int selected_num;

float mx;
float my;

/*--------------------------------------------------------------------------*/

void game_init();
void game_exec();
void game_draw();
void block_move();
void block_iginite();
void back_draw();
void block_draw();

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	mx = (FIELD_WIDTH  / 2);
	my = (FIELD_HEIGHT / 2);

	game_init();

	for(;;) {
		schedule();
		play_timer++;

		if(joy & TRG_SELECT) {
			if(play_timer >= SEC(1)) {
				game_init();
			} else {
				exit(0);
			}
		}

		if(joy & PAD_LF) {
			mx -= 4.0f;
			if(mx < 40.0f) {
				mx = 40.0f;
			}
		}
		if(joy & PAD_RI) {
			mx += 4.0f;
			if(mx > 600.0f) {
				mx = 600.0f;
			}
		}
		if(joy & PAD_UP) {
			my -= 4.0f;
			if(my < 40.0f) {
				my = 40.0f;
			}
		}
		if(joy & PAD_DN) {
			my += 4;
			if(my > 440.0f) {
				my = 440.0f;
			}
		}

		game_exec();
		game_draw();
	}
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(block_array, -1, sizeof block_array);
	memset(block_v_count, 0, sizeof block_v_count);

	play_timer = 0;
	selected_num = -1;
}

/****************************************************************************
 *	game_exec
 ****************************************************************************/

void
game_exec()
{
	int cnt;
	BLOCK* block;
	float dx;
	float dy;
	float d;
	float dist;

	/* d */
	if(!(play_timer % 3)) {
		for(cnt = 0; cnt < BLOCK_MAX; cnt++) {
			block = &block_array[cnt];
			if(block->type < 0) {
				continue;
			}
			/* SE~ */
			dx = block->x - (FIELD_WIDTH  / 2);
			dy = block->y - (FIELD_HEIGHT / 2);
			d = float_sqrt((dx * dx) + (dy * dy));
			if(d) {
				dx /= d;
				dy /= d;
				block->sx -= 0.1f * dx;
				block->sy -= 0.1f * dy;
			}
		}
	}

	/* _ǉ */
	if(!(play_timer % SEC(1)) || (joy & TRG_B)) {
		for(cnt = 0; cnt < BLOCK_MAX; cnt++) {
			block = &block_array[cnt];
			if(block->type < 0) {
				memset(block, 0, sizeof(BLOCK));
				block->type = RND16_RANGE(seed, 0, BLOCK_TYPE_MAX);
				if(!(RND16(seed) & 1)) {
					block->x  =           0 - (BLOCK_SIZE / 2);
					block->sx =  2.0f;
				}else{
					block->x  = FIELD_WIDTH + (BLOCK_SIZE / 2);
					block->sx = -2.0f;
				}
				block->y = RND16_RANGE(seed,
					(int)(           0 - (BLOCK_SIZE / 2)),
					(int)(FIELD_HEIGHT + (BLOCK_SIZE / 2)));
				break; /* ܂ */
			}
		}
	}

	if(joy & PAD_A) {
		/* hbN(L[ꂽu) */
		if(joy & TRG_A) {
			selected_num = -1;
			dist = (BLOCK_SIZE * BLOCK_SIZE);
			for(cnt = 0; cnt < BLOCK_MAX; cnt++) {
				block = &block_array[cnt];
				if(block->type < 0) {
					continue;
				}
				dx = block->x - mx;
				dy = block->y - my;
				d = (dx * dx) + (dy * dy);
				if(d < dist){
					selected_num = cnt;
					dist = d;
				}
			}
		/* hbN(L[Ă) */
		} else if(selected_num >= 0) {
			block = &block_array[selected_num];
			if(block->type >= 0) {
				dx = mx - block->x;
				dy = my - block->y;
				d = float_sqrt((dx * dx) + (dy * dy));
				if(d > DRAG_MAX) {
					dx *= DRAG_MAX / d;
					dy *= DRAG_MAX / d;
				}
				block->sx = dx * 0.2f;
				block->sy = dy * 0.2f;
			} else {
				selected_num = -1;
			}
		}
	} else {
		selected_num = -1;
	}

	block_move();
	block_iginite();
}

/****************************************************************************
 *	game_draw
 ****************************************************************************/

void
game_draw()
{
	int cnt;
	BLOCK* block;
	int n;
	int x;
	int y;

	back_draw();

	n = 0;
	for(cnt = 0; cnt < BLOCK_MAX; cnt++) {
		block = &block_array[cnt];
		if(block->type >= 0) {
			n++;
		}
	}
	x = 128 - 40;
	y = 1;
	render_printf(&render, x, y, 0x82, 0, "NBLOCK:%3d", n);
	//
	y += 12;
	n = block_v_count[0] < 999 ? block_v_count[0] : 999;
	render_printf(&render, x, y, 0x82, 0, "CIRCLE:%3d", n);
	//
	y += 6;
	n = block_v_count[1] < 999 ? block_v_count[1] : 999;
	render_printf(&render, x, y, 0x82, 0, "SQUARE:%3d", n);
	//
	y += 6;
	n = block_v_count[2] < 999 ? block_v_count[2] : 999;
	render_printf(&render, x, y, 0x82, 0, "TRIANG:%3d", n);
	//
	y += 6;
	n = block_v_count[3] < 999 ? block_v_count[3] : 999;
	render_printf(&render, x, y, 0x82, 0, "STAR  :%3d", n);

	x = 1;
	y = 88 - 18;
	render_string(&render, x, y, "[A]:DRAG & MOVE", 0x82, 0);
	y += 6;
	render_string(&render, x, y, "[B]:ADD BLOCK", 0x82, 0);
	y += 6;
	if(play_timer >= SEC(1)) {
		render_string(&render, x, y, "[SEL]:RESET", 0x82, 0);
	} else {
		render_string(&render, x, y, "[SEL]:EXIT", 0x82, 0);
	}

	block_draw();

	x = mx * (float)(128.0f / 640.0f);
	y = my * (float)( 88.0f / 480.0f);
	sprite_draw(x, y, SPR_CURSOR, DRW_NOMAL);
}

/****************************************************************************
 *	block_move
 ****************************************************************************/

void
block_move()
{
	int cnt1;
	BLOCK* block1;
	int cnt2;
	BLOCK* block2;
	float dist;
	float dist_x;
	float dist_y;
	float dist_px;
	float dist_py;
	float x;
	float potencial;

	for(cnt1 = 0; cnt1 < BLOCK_MAX; cnt1++) {
		block1 = &block_array[cnt1];
		if(block1->type < 0) {
			continue;
		}

		/* ɏ]ړ */
		block1->x += block1->sx;
		block1->y += block1->sy;

		/* x */
		if(!(play_timer & 3)) {
			block1->sx *= 0.95f;
			block1->sy *= 0.95f;
		}

		/* ubN̏𕪎Uĕׂ炷 */
		/* ̏̃VXe̖ڋʂȂzB */
		/* cwȂ̗FBɂ̘bA */
		/* uʎq͊ŵҁ[݂[ɎĂˁv */
		/* ČꂽBV~[V܂n */
		if((play_timer ^ cnt1) & 1) {
			continue;
		}

		/* ǔ */
		if(block1->x >  FIELD_WIDTH + (BLOCK_SIZE / 2)) {
		   block1->x =  FIELD_WIDTH + (BLOCK_SIZE / 2);
		   block1->sx *= -(FIELD_REFLECT);
		}
		if(block1->x <            0 - (BLOCK_SIZE / 2)) {
		   block1->x =            0 - (BLOCK_SIZE / 2);
		   block1->sx *= -(FIELD_REFLECT);
		}
		if(block1->y > FIELD_HEIGHT + (BLOCK_SIZE / 2)) {
		   block1->y = FIELD_HEIGHT + (BLOCK_SIZE / 2);
		   block1->sy *= -(FIELD_REFLECT);
		}
		if(block1->y <            0 - (BLOCK_SIZE / 2)) {
		   block1->y =            0 - (BLOCK_SIZE / 2);
		   block1->sy *= -(FIELD_REFLECT);
		}

		/* Փ˔ */
		for(cnt2 = 0; cnt2 < cnt1; cnt2++) {
			block2 = &block_array[cnt2];
			if(block2->type < 0) {
				continue;
			}

			/*  */
			dist_x = block2->x - block1->x;
//{{
			if(float_fabs(dist_x) >= (BLOCK_SIZE * 2.5f)) {
				continue;
			}
//}}
			dist_y = block2->y - block1->y;
//{{
			if(float_fabs(dist_y) >= (BLOCK_SIZE * 2.5f)) {
				continue;
			}
//}}
			dist = float_sqrt((dist_x * dist_x) + (dist_y * dist_y));
			if(!dist) {
				continue;
			}
			dist_x /= dist;
			dist_y /= dist;

			/* Փ˂! */
			if(dist < BLOCK_SIZE) {
				/* ߂荞݂h */
				dist_px = dist_x * (BLOCK_SIZE - dist) / 2.0f;
				dist_py = dist_y * (BLOCK_SIZE - dist) / 2.0f;
				block2->x += dist_px;
				block2->y += dist_py;
				block1->x -= dist_px;
				block1->y -= dist_py;
				block2->sx *= 0.9f;
				block2->sy *= 0.9f;
				block1->sx *= 0.9f;
				block1->sy *= 0.9f;
			}

			/* |eVGlM[̒ႢɗB */
			/* exp(-x^2)Ȃ̂ŁA2*x*exp(-x^2)̕։ */
			x = dist - (BLOCK_SIZE * 1.5f);
			//if(x < 31.606961258558216545204213985699f/*=999.0f*/) {
			//
			if(x < BLOCK_SIZE) {
				//potencial = -4.0f * x;
				//
				potencial = -5.0f * x;
				x *= x; /* x^2 */
				x *= x; /* x^4 */
				potencial *= float_exp(-x);
				dist_px = dist_x * potencial;
				dist_py = dist_y * potencial;
				block2->sx += dist_px;
				block2->sy += dist_py;
				block1->sx -= dist_px;
				block1->sy -= dist_py;
			}
		}
	}
}

/****************************************************************************
 *	block_iginite
 ****************************************************************************/


void
block_iginite()
{
	static float block_density[BLOCK_MAX];	/* ubNZx */
	//
	int cnt1;
	BLOCK* block1;
	int cnt2;
	BLOCK* block2;
	float dx;
	float dy;
	float d;
	float rate;

	/* 菉 */
	memset(block_density, 0, sizeof block_density);

	/* ZxvZ */
	for(cnt1 = 0; cnt1 < BLOCK_MAX; cnt1++) {
		block1 = &block_array[cnt1];
		if(block1->type < 0) {
			continue;
		}

		for(cnt2 = 0; cnt2 < cnt1; cnt2++) {
			block2 = &block_array[cnt2];
			if(block2->type < 0) {
				continue;
			}

			if(block1->type != block2->type) {
				continue;
			}

			dx = block2->x - block1->x;
			dy = block2->y - block1->y;
			d = float_sqrt((dx * dx) + (dy * dy));
			if(!d) {
				continue;
			}
			rate = BLOCK_SIZE / d;
			rate = rate * rate * rate;
			if(rate > 1.0f) {
				rate = 1.0f;
			}

			if(block1->ignited > (BLOCK_VANISH_DELAY / 2)) {		/* Ύ͕␳ */
				block_density[cnt2] += rate * BLOCK_INGNITED_EFFECT;
			} else {
				block_density[cnt2] += rate;
			}
			if(block2->ignited > (BLOCK_VANISH_DELAY / 2)) {		/* Ύ͕␳ */
				block_density[cnt1] += rate * BLOCK_INGNITED_EFFECT;
			} else {
				block_density[cnt1] += rate;
			}
		}
	}

	/* ŏ */
	for(cnt1 = 0; cnt1 < BLOCK_MAX; cnt1++) {
		block1 = &block_array[cnt1];
		if(block1->type < 0) {
			continue;
		}

		if(block1->ignited) {
			block1->ignited++;
			if(block1->ignited > BLOCK_VANISH_DELAY) {
				/* S */
				block_v_count[block1->type]++;
				memset(block1, -1, sizeof(BLOCK));
			}
		} else {
			if(block_density[cnt1] > BLOCK_DENSITY_THREATHOLD) {
				/*  */
				block1->ignited = 1;
			}
		}
	}
}

/****************************************************************************
 *	back_draw
 ****************************************************************************/

void
back_draw()
{
	int spr;

	spr = SPR_BACK00;
	spr += play_timer % 30;
	sprite_draw(0, 0, spr, DRW_NOMAL);
}

/****************************************************************************
 *	block_draw
 ****************************************************************************/

void
block_draw()
{
	static int block_rot[BLOCK_TYPE_MAX];
	static float vanish_rot;
	//
	int cnt;
	BLOCK* block;
	int i;
	int x;
	int y;
	int spr;
	float sz;

	i = (play_timer % 150);
	if(i >=  0 && i <=  9) block_rot[0]++;
	if(i >= 30 && i <= 39) block_rot[1]++;
	if(i >= 60 && i <= 69) block_rot[2]++;
	if(i >= 90 && i <= 99) block_rot[3]++;
	for(cnt = 0; cnt < BLOCK_TYPE_MAX; cnt++) {
		if(!(play_timer & 7)) {
			block_rot[cnt]++;
		}
		block_rot[cnt] &= 31;
	}

	for(cnt = 0; cnt < BLOCK_MAX; cnt++) {
		block = &block_array[cnt];
		if(block->type < 0) {
			continue;
		}
		x = block->x * (float)(128.0f / 640.0f);
		y = block->y * (float)( 88.0f / 480.0f);
		spr = SPR_BLOCK0_00;
		spr += block->type * 32;
		spr += block_rot[block->type];
		sprite_draw(x, y, spr, DRW_NOMAL);
	}

	vanish_rot += (float)(M_PI / 5);
	if(vanish_rot >= (float)M_PI) {
		vanish_rot -= (float)M_PI2;
	}
	//if(!(play_timer & 1)) {
		for(cnt = 0; cnt < BLOCK_MAX; cnt++) {
			block = &block_array[cnt];
			if(block->type < 0) {
				continue;
			}
			if(block->ignited) {
				switch(block->ignited) {
				case 1:
					sz = 0.5f;
					break;
				case (BLOCK_VANISH_DELAY - 1):
					sz = 1.0f;
					break;
				default:
					sz = 0.25f + 0.25f * block->ignited / BLOCK_VANISH_DELAY;
					break;
				}
				x = block->x * (float)(128.0f / 640.0f);
				y = block->y * (float)( 88.0f / 480.0f);
				spr = SPR_VANISH;
				sprite_draw2(x, y, spr, DRW_NOMAL, fld(sz), fld(sz), fld(vanish_rot));
			}
		}
	//}
}

